# generated by datamodel-codegen:
#   filename:  properties_directory/structural/lattice.json
#   version:   0.28.5

from __future__ import annotations

from enum import Enum
from typing import List, Optional

from pydantic import BaseModel, Field


class Units(Enum):
    km = "km"
    m = "m"
    cm = "cm"
    mm = "mm"
    um = "um"
    nm = "nm"
    angstrom = "angstrom"
    a_u_ = "a.u."
    bohr = "bohr"
    pm = "pm"


class LatticeExplicitUnit(BaseModel):
    alat: Optional[float] = 1
    """
    lattice parameter for fractional coordinates
    """
    units: Optional[Units] = None
    a: List[float] = Field(..., max_length=3, min_length=3, title="array of 3 number elements schema")
    b: List[float] = Field(..., max_length=3, min_length=3, title="array of 3 number elements schema")
    c: List[float] = Field(..., max_length=3, min_length=3, title="array of 3 number elements schema")


class LatticeTypeEnum(Enum):
    CUB = "CUB"
    BCC = "BCC"
    FCC = "FCC"
    TET = "TET"
    MCL = "MCL"
    ORC = "ORC"
    ORCC = "ORCC"
    ORCF = "ORCF"
    ORCI = "ORCI"
    HEX = "HEX"
    BCT = "BCT"
    TRI = "TRI"
    MCLC = "MCLC"
    RHL = "RHL"


class Length(Enum):
    angstrom = "angstrom"
    bohr = "bohr"


class Angle(Enum):
    degree = "degree"
    radian = "radian"


class LatticeUnitsSchema(BaseModel):
    length: Optional[Length] = "angstrom"
    angle: Optional[Angle] = "degree"


class LatticeSchema(BaseModel):
    vectors: Optional[LatticeExplicitUnit] = Field(None, title="lattice explicit unit")
    type: Optional[LatticeTypeEnum] = Field("TRI", title="lattice type enum")
    units: Optional[LatticeUnitsSchema] = Field(
        default_factory=lambda: LatticeUnitsSchema.model_validate({"length": "angstrom", "angle": "degree"}),
        title="Lattice units schema",
    )
    a: float
    """
    length of the first lattice vector
    """
    b: float
    """
    length of the second lattice vector
    """
    c: float
    """
    length of the third lattice vector
    """
    alpha: float
    """
    angle between first and second lattice vector
    """
    beta: float
    """
    angle between second and third lattice vector
    """
    gamma: float
    """
    angle between first and third lattice vector
    """
